// Copyright 2020-2022 Manta Network.
// This file is part of Manta.
//
// Manta is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Manta is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Manta.  If not, see <http://www.gnu.org/licenses/>.

//! Autogenerated weights for pallet_membership
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2022-07-18, STEPS: `50`, REPEAT: 20, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("calamari-dev"), DB CACHE: 1024

// Executed Command:
// manta
// benchmark
// pallet
// --chain=calamari-dev
// --pallet=pallet_membership
// --extrinsic=*
// --execution=Wasm
// --wasm-execution=Compiled
// --heap-pages=4096
// --repeat=20
// --steps=50
// --template=.github/resources/frame-weight-template.hbs
// --output=pallet_membership.rs

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(clippy::unnecessary_cast)]

use frame_support::{traits::Get, weights::{Weight, constants::RocksDbWeight}};
use sp_std::marker::PhantomData;

/// Weight functions needed for pallet_membership.
pub trait WeightInfo {
    fn add_member(m: u32, ) -> Weight;
    fn remove_member(m: u32, ) -> Weight;
    fn swap_member(m: u32, ) -> Weight;
    fn reset_member(m: u32, ) -> Weight;
    fn change_key(m: u32, ) -> Weight;
    fn set_prime(m: u32, ) -> Weight;
    fn clear_prime(m: u32, ) -> Weight;
}

/// Weights for pallet_membership using the Substrate node and recommended hardware.
pub struct SubstrateWeight<T>(PhantomData<T>);
impl<T: frame_system::Config> pallet_membership::WeightInfo for SubstrateWeight<T> {
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn add_member(m: u32, ) -> Weight {
        (15_525_000 as Weight)
            // Standard Error: 1_000
            .saturating_add((60_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(T::DbWeight::get().reads(2 as Weight))
            .saturating_add(T::DbWeight::get().writes(3 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: CouncilMembership Prime (r:1 w:0)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn remove_member(m: u32, ) -> Weight {
        (19_090_000 as Weight)
            // Standard Error: 0
            .saturating_add((46_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(T::DbWeight::get().reads(3 as Weight))
            .saturating_add(T::DbWeight::get().writes(3 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: CouncilMembership Prime (r:1 w:0)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn swap_member(m: u32, ) -> Weight {
        (19_116_000 as Weight)
            // Standard Error: 0
            .saturating_add((61_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(T::DbWeight::get().reads(3 as Weight))
            .saturating_add(T::DbWeight::get().writes(3 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: CouncilMembership Prime (r:1 w:0)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn reset_member(m: u32, ) -> Weight {
        (18_658_000 as Weight)
            // Standard Error: 1_000
            .saturating_add((194_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(T::DbWeight::get().reads(3 as Weight))
            .saturating_add(T::DbWeight::get().writes(3 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: CouncilMembership Prime (r:1 w:1)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn change_key(m: u32, ) -> Weight {
        (19_688_000 as Weight)
            // Standard Error: 1_000
            .saturating_add((59_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(T::DbWeight::get().reads(3 as Weight))
            .saturating_add(T::DbWeight::get().writes(4 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:0)
    // Storage: CouncilMembership Prime (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn set_prime(m: u32, ) -> Weight {
        (5_444_000 as Weight)
            // Standard Error: 0
            .saturating_add((30_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(T::DbWeight::get().reads(1 as Weight))
            .saturating_add(T::DbWeight::get().writes(2 as Weight))
    }
    // Storage: CouncilMembership Prime (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn clear_prime(m: u32, ) -> Weight {
        (1_808_000 as Weight)
            // Standard Error: 0
            .saturating_add((1_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(T::DbWeight::get().writes(2 as Weight))
    }
}

// For backwards compatibility and tests
impl WeightInfo for () {
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn add_member(m: u32, ) -> Weight {
        (15_525_000 as Weight)
            // Standard Error: 1_000
            .saturating_add((60_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(RocksDbWeight::get().reads(2 as Weight))
            .saturating_add(RocksDbWeight::get().writes(3 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: CouncilMembership Prime (r:1 w:0)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn remove_member(m: u32, ) -> Weight {
        (19_090_000 as Weight)
            // Standard Error: 0
            .saturating_add((46_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(RocksDbWeight::get().reads(3 as Weight))
            .saturating_add(RocksDbWeight::get().writes(3 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: CouncilMembership Prime (r:1 w:0)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn swap_member(m: u32, ) -> Weight {
        (19_116_000 as Weight)
            // Standard Error: 0
            .saturating_add((61_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(RocksDbWeight::get().reads(3 as Weight))
            .saturating_add(RocksDbWeight::get().writes(3 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: CouncilMembership Prime (r:1 w:0)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn reset_member(m: u32, ) -> Weight {
        (18_658_000 as Weight)
            // Standard Error: 1_000
            .saturating_add((194_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(RocksDbWeight::get().reads(3 as Weight))
            .saturating_add(RocksDbWeight::get().writes(3 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:1)
    // Storage: Council Proposals (r:1 w:0)
    // Storage: CouncilMembership Prime (r:1 w:1)
    // Storage: Council Members (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn change_key(m: u32, ) -> Weight {
        (19_688_000 as Weight)
            // Standard Error: 1_000
            .saturating_add((59_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(RocksDbWeight::get().reads(3 as Weight))
            .saturating_add(RocksDbWeight::get().writes(4 as Weight))
    }
    // Storage: CouncilMembership Members (r:1 w:0)
    // Storage: CouncilMembership Prime (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn set_prime(m: u32, ) -> Weight {
        (5_444_000 as Weight)
            // Standard Error: 0
            .saturating_add((30_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(RocksDbWeight::get().reads(1 as Weight))
            .saturating_add(RocksDbWeight::get().writes(2 as Weight))
    }
    // Storage: CouncilMembership Prime (r:0 w:1)
    // Storage: Council Prime (r:0 w:1)
    fn clear_prime(m: u32, ) -> Weight {
        (1_808_000 as Weight)
            // Standard Error: 0
            .saturating_add((1_000 as Weight).saturating_mul(m as Weight))
            .saturating_add(RocksDbWeight::get().writes(2 as Weight))
    }
}
